/****
	*	@Project	:	Text Manager for CP300
	*	@COpyright	:	2004 Na-Prod.com
	*	@File		:	TextDocument.cpp	
	*	@Author(s)	:	Superna@na-prod.com
	*				:	
	*				:	
	*	@Synopsys	:	Text Document Handler Code
	*
****/

#define FALSE 	0
#define TRUE	1

#include "TextDocument.h"

const PEGCHAR* TEXTMANAGER_MEMTYPE_HEADER = "TextManager";
const PEGCHAR* TEXTMANAGER_MEMTYPE_SAVED_STATE = "Text";

#define PATH nsDoc::TextDocument

PATH::TextDocument(CPMainFrame * frame)
	: CPDocument(frame), Name("UnNamed"), Folder("main"), IsSaved(FALSE)
{
    
}//TextDocument    
          
char * PATH::ReadNew()
{
    StorageManager *manager = new StorageManager(&Name,&Folder, STORAGE_ACTION_OPEN, IMU_MCS_TypeMem);
	int ret = manager->Execute();

	if (ret != IDB_STORAGE_OPEN) 
  		return NULL;  	
	
 	CPReadMCSFile f(Name.Text(),Folder.Text(),IMU_MCS_TypeMem);
	
	Read(f);
	
	return m_text.getText();
	
}//ReadNew
    
void PATH::SaveIt()
{
	if(!IsSaved)
		SaveAs();
 	else
 	{
 		CPWriteMCSFile f(Name.Text(),Folder.Text(),IMU_MCS_TypeMem);
	
		Write(f);
	}	
}//SaveIt
    
void PATH::New()
{
    IsSaved = FALSE;
	Name = "NoName";
	Folder = "main";
}    
    
void PATH::SaveAs()
{
    StorageManager *manager = new StorageManager(&Name,&Folder, STORAGE_ACTION_SAVE, IMU_MCS_TypeMem);
	int ret = manager->Execute();

	if (ret != IDB_STORAGE_SAVE) 
    	return; 	
	
 	CPWriteMCSFile f(Name.Text(),Folder.Text(),IMU_MCS_TypeMem);
	
	Write(f);
	f.Realize();
	Write(f);
	
	IsSaved = TRUE;
}//SaveAs                
                
void PATH::Read(CPReadFile &f)
{
	if (f.FileExists())
	{
		CPMEMFileHeader header(TEXTMANAGER_MEMTYPE_HEADER, TEXTMANAGER_MEMTYPE_SAVED_STATE);
		header.Read(f);

		if(f.IsNotError())
		{
			m_text.Read(f);
		}
	}		
}//Read    

void PATH::Write(CPWriteFile &f)
{
	CPMEMFileHeader header(TEXTMANAGER_MEMTYPE_HEADER, TEXTMANAGER_MEMTYPE_SAVED_STATE);
	header.Write(f);

	if(f.IsNotError())
	{
		m_text.Write(f);
	}

}//Write    
