/****
	*	@Project	:	Text Manager for CP300
	*	@COpyright	:	2004 Na-Prod.com
	*	@File		:	TextWindow.cpp	
	*	@Author(s)	:	Superna@na-prod.com
	*				:	
	*				:	
	*	@Synopsys	:	Window Handler Code
	*
****/

#include "TextWindow.h"

extern PegBitmap gbnewBitmap;
extern PegBitmap gbopenBitmap;
extern PegBitmap gbsaveBitmap;
extern PegBitmap gbTextManagerBitmap;

#define PATH nsWin::TextWindow

PegMenuDescriptionML  PATH::MainMenu[] = 
		{ {"?", CMN_NO_ID, 0, AF_ENABLED, SubHelp }, 
		  {"Edit", CMN_NO_ID, 0, AF_ENABLED, SubEdit },
	      {"File", CMN_NO_ID, 0, AF_ENABLED, SubFile },
		{"", CMN_NO_ID, 0, 0, 0} }; 
		
PegMenuDescriptionML  PATH::SubFile[] = 
		{ {"Reset", CMN_NO_ID, ID_MENU_RESET, AF_ENABLED, NULL }, 
		{"Open", CMN_NO_ID, ID_MENU_OPEN, AF_ENABLED, NULL },
		{"Save", CMN_NO_ID, ID_MENU_SAVE, AF_ENABLED, NULL },
		{"Save As", CMN_NO_ID, ID_MENU_SAVEAS, AF_ENABLED, NULL },
		{"", CMN_NO_ID, 0, 0, 0} };
		
PegMenuDescriptionML  PATH::SubEdit[] = 
		{ {"Select All", CMN_NO_ID, ID_MENU_SELECTALL, AF_ENABLED, NULL }, 
		{"Copy", CMN_NO_ID, PM_COPY, AF_ENABLED, NULL },
		{"Cut", CMN_NO_ID, PM_CUT, AF_ENABLED, NULL },
		{"Paste", CMN_NO_ID, PM_PASTE, AF_ENABLED, NULL },
		{"", CMN_NO_ID, 0, 0, 0} };

PegMenuDescriptionML  PATH::SubHelp[] = 
		{ {"About", CMN_NO_ID, ID_MENU_ABOUT, AF_ENABLED, NULL }, 
		{"", CMN_NO_ID, 0, 0, 0} };

PATH::TextWindow(PegRect rect, nsDoc::TextDocument * doc, CPMainFrame * frame)
	: CPModuleWindow(rect, 0, doc, frame)
{
    this->Style(FF_NONE);
    Doc = doc;
    Init();
}//TextWindow    

void PATH::Init()
{
	m_text = new TextEditor(mClient);
	Add(m_text);
}//Init

void PATH::StatusBar()
{
	PegStatusBar *bar = GetStatusBar();
	CPString status = "Filename: ";
	status += Doc->getName(); // + "@" + Doc->getFolder();

	bar->SetTextField(1,status);	
}//StatusBar    

void PATH::Draw()
{
    BeginDraw();
	DrawFrame();
	m_text->Resize(mClient);
	DrawChildren();
	EndDraw();
}//Draw    

SIGNED PATH::Message(const PegMessage &Mesg)
{
    switch(Mesg.wType)
    {
        case SIGNAL( ID_MENU_ABOUT, PSF_CLICKED):
            AboutPopup();
            break;
        case SIGNAL( TB_BUT_CLOSE , PSF_CLICKED):
            m_text->DataSet(NULL);
            m_text->Draw();
            Doc->New();
            StatusBar();
            break;
        case SIGNAL( TB_BUT_OPEN , PSF_CLICKED):
            m_text->DataSet(Doc->ReadNew());
            m_text->Draw();
            StatusBar();
            break;
        case SIGNAL( TB_BUT_SAVE , PSF_CLICKED):
            Doc->setText(m_text->DataGet());
            Doc->SaveIt();
            StatusBar();
            break;
        case SIGNAL( ID_MENU_SAVEAS , PSF_CLICKED):
            Doc->setText(m_text->DataGet());
            Doc->SaveAs();
            StatusBar();
            break;
        case SIGNAL( ID_MENU_SELECTALL , PSF_CLICKED):
            m_text->SelectAll();
            break;
        default:
            return CPModuleWindow::Message(Mesg);
	} 
 	return 0;   
} //Message  

void PATH::AddUI()
{
    PegRect rr = GetToolbarButtonRect();
    m_ui->AddToolbarButton(new PegBitmapButton(rr, &gbnewBitmap, TB_BUT_CLOSE));
    m_ui->AddToolbarButton(new PegBitmapButton(rr, &gbopenBitmap, TB_BUT_OPEN));
    m_ui->AddToolbarButton(new PegBitmapButton(rr, &gbsaveBitmap, TB_BUT_SAVE));
}//AddUI()     

void PATH::AboutPopup(void)
{
    PegMessageWindow *pWin = new PegMessageWindow("About Text Manager",
        "Text Manager by Superna",
        MW_OK);
    /*CPDialog * pWin = new CPDialog(CP_DIALOG_SIZE_HALF, CP_DIALOG_POS_CENTER, "About Text Manager");
    
    CPRect rect(0, 0, 45, 28);
    rect.Center(mClient, 3);
    pWin->Add(new PegBitmapButton(rect, &gbTextManagerBitmap, FF_NONE));
    */
    Presentation()->Center(pWin);
    Presentation()->Add(pWin);
    pWin->Execute();
}

PegMenuDescriptionML* PATH::GetMenuDescriptionML() 
{ return MainMenu; }
